\name{downsample}
\alias{downsample}
\title{Downsample a matrix}
\description{Produce a smaller matrix by averaging submatrices of
adjacent cells, with optional reordering/subsetting and row/column
mean centering}
\usage{
downsample(x, rres, cres, ridx = 1:nrow(x), cidx = 1:ncol(x),
  rcenter = TRUE, ccenter = TRUE )
}
\arguments{
\item{x}{The matrix to be downsampled}
\item{rres}{row submatrix block size}
\item{cres}{column submatrix block size}
\item{ridx}{row indices}
\item{cidx}{column indices}
\item{rcenter}{row mean centering}
\item{ccenter}{column mean centering}
}

\value{A matrix of averages of the submatrices, with attributes
\code{mean} and \code{sd}, corresponding to the mean and sd of
the cells of the output matrix}
\author{Pratyaksha Wirapati}

